Skip to content

REST API

Nella provides a hosted REST API for programmatic access to search, context, and workspace management.

Nella provides a hosted REST API for programmatic access to search, context, and workspace management.

Base URL

https://mcp.getnella.dev/api/v1

Authentication

Include your API key in the request headers:

curl -H "Authorization: Bearer nella_your_api_key" \
  https://mcp.getnella.dev/api/v1/health

Rate Limits

WindowLimit
Per minute60 requests
Per hour1,000 requests
Per day10,000 requests

Rate limit headers are included in every response: X-RateLimit-Limit, X-RateLimit-Remaining, X-RateLimit-Reset.

Endpoints

Health

MethodPathDescription
GET/healthServer health check
MethodPathDescription
POST/searchSearch indexed codebase
POST/search/batchBatch search queries

Workspaces

MethodPathDescription
GET/workspacesList workspaces
POST/workspacesRegister a workspace
GET/workspaces/:idGet workspace details
DELETE/workspaces/:idRemove a workspace
POST/workspaces/:id/indexTrigger indexing

Context

MethodPathDescription
GET/contextGet session context
POST/context/assumptionsAdd an assumption
GET/context/assumptionsList assumptions
POST/context/assumptions/checkVerify assumptions
GET/context/dependenciesCheck dependency status
GET/context/changesList recent changes

Auth

MethodPathDescription
POST/auth/keysCreate API key
GET/auth/keysList API keys
DELETE/auth/keys/:idRevoke API key
GET/auth/usageView usage stats

Plans

Some features and limits vary by plan:

FeatureFreeProTeam
Workspaces310Unlimited
Search queries / day1005,00050,000
Index size50MB500MB5GB
API accessLimitedFullFull

Error Responses

All errors follow a consistent format:

{
  "error": {
    "code": "rate_limit_exceeded",
    "message": "Rate limit exceeded. Try again in 30 seconds."
  }
}

Standard HTTP status codes: 200 success, 400 bad request, 401 unauthorized, 403 forbidden, 404 not found, 429 rate limited, 500 server error.